﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Siticone.Desktop.UI.WinForms;

namespace POS.UserControls
{
    public partial class PlaceOrderForm : Form
    {
        public PlaceOrderForm(Point location)
        {
            InitializeComponent();
            Location = location;
            new SiticoneShadowForm(this);
        }

        private void ProductsDropdown_SelectedIndexChanged(object sender, EventArgs e)
        {
            ProductTb.Text = ProductsDropdown.SelectedItem.ToString();
            PlaceOrderBtn.Enabled = true;
        }

        private void UnitPrice_ValueChanged(object sender, EventArgs e)
        {
            UnitPriceTb.Text = "$ " + UnitPrice.Value.ToString();
            TotalPrice();
        }

        private void Quantity_ValueChanged(object sender, EventArgs e)
        {
            QuantityTb.Text = Quantity.Value.ToString();
            TotalPrice();
        }

        private void TotalPrice()
        {
            TotalTb.Text = "$ " + Convert.ToString(UnitPrice.Value * Quantity.Value) + " USD";
            PlaceOrderBtn.Text = $"Place Order of {"$ " + Convert.ToString(UnitPrice.Value * Quantity.Value) + " USD"}";
        }

        private void PlaceOrderBtn_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrWhiteSpace(CustomerName.Text))
            {
                MessageBox.Show("Please provide the customer name");
                return;
            }

            Random random = new Random();
            var firstID = random.Next(100, 999);
            var secondId = random.Next(100, 999);
            var customerID = firstID.ToString() + "-" + secondId.ToString();

            var totalPrice = "$ " + Convert.ToString(UnitPrice.Value * Quantity.Value) + " USD";

            var openForms = Application.OpenForms;
            foreach (Form parent in openForms)
            {
                if (parent.Name == "MainPage")
                {
                    parent.Controls.Find("OrdersContainer", true)[0].Controls.Add(new NewOrder(customerID, CustomerName.Text, ProductsDropdown.SelectedItem.ToString(), totalPrice, Quantity.Value.ToString(), UnitPrice.Value.ToString()));
                }
            }

            Close();
        }
    }
}
